nx_metadata_sdk 1.0 Metadata SDK

Public Types | Public Member Functions | Protected Member Functions | List of all members
nx::vms_server_plugins::analytics::stub::Engine Class Reference
Inheritance diagram for nx::vms_server_plugins::analytics::stub::Engine:

## Public Types
using | PixelFormat = nx::sdk::analytics::IUncompressedVideoFrame::PixelFormat

## Public Member Functions
| Engine (nx::sdk::analytics::Plugin *plugin)
bool | needUncompressedVideoFrames () const
PixelFormat | pixelFormat () const
Public Member Functions inherited from nx::sdk::analytics::Engine
virtual void | setEngineInfo (const IEngineInfo *engineInfo) override
virtual void | setHandler (IEngine::IHandler *handler) override
virtual bool | isCompatible (const IDeviceInfo *deviceInfo) const override
Public Member Functions inherited from nx::sdk::RefCountable< IEngine >
| RefCountable (const RefCountable &)=delete
| RefCountable (RefCountable &&)=delete
RefCountable & | operator= (const RefCountable &)=delete
RefCountable & | operator= (RefCountable &&)=delete
virtual int | addRef () const override
virtual int | releaseRef () const override
int | refCount () const

## Protected Member Functions
virtual std::string | manifestString () const override
virtual nx::sdk::Result< const nx::sdk::IStringMap * > | settingsReceived () override
virtual void | doObtainDeviceAgent (nx::sdk::Result< nx::sdk::analytics::IDeviceAgent *> *outResult, const nx::sdk::IDeviceInfo *deviceInfo) override
virtual nx::sdk::Result< sdk::analytics::IAction::Result > | executeAction (const std::string &actionId, nx::sdk::Uuid trackId, nx::sdk::Uuid deviceId, int64_t timestampUs, nx::sdk::Ptr< nx::sdk::analytics::IObjectTrackInfo > objectTrackInfo, const std::map< std::string, std::string > &params) override
Protected Member Functions inherited from nx::sdk::analytics::Engine
| Engine (bool enableOutput)
std::string | settingValue (const std::string &settingName)
void | pushPluginDiagnosticEvent (IPluginDiagnosticEvent::Level level, std::string caption, std::string description)
IHandler * | handler () const
virtual void | doSetSettings (Result< const IStringMap *> *outResult, const IStringMap *settings) override
virtual void | getPluginSideSettings (Result< const ISettingsResponse *> *outResult) const override
virtual void | getManifest (Result< const IString *> *outResult) const override
virtual void | doExecuteAction (Result< IAction::Result > *outResult, const IAction *action) override

## Additional Inherited Members
Protected Attributes inherited from nx::sdk::analytics::Engine
LogUtils | logUtils

## Member Function Documentation

## ◆ executeAction()

Result< IAction::Result > nx::vms_server_plugins::analytics::stub::Engine::executeAction | ( | const std::string & | ,
|  | nx::sdk::Uuid | ,
|  | nx::sdk::Uuid | ,
|  | int64_t | ,
|  | nx::sdk::Ptr< nx::sdk::analytics::IObjectTrackInfo > | ,
|  | const std::map< std::string, std::string > & |
| ) |  |
| override protected virtual

Action handler. Called when some action defined by this engine is triggered by Server.

Parameters

  actionId | Id of the action being triggered.
  objectTrackId | Id of an object track for which the action has been triggered.
  params | If the engine manifest defines params for the action being triggered, contains their values after they are filled by the user via Client form. Otherwise, empty.
  outActionUrl | If set by this call, Client will open this URL in an embedded browser.
  outMessageToUser | If set by this call, Client will show this text to the user.

Reimplemented from nx::sdk::analytics::Engine.

## ◆ settingsReceived()

Result< const IStringMap * > nx::vms_server_plugins::analytics::stub::Engine::settingsReceived | ( |  | ) |
| override protected virtual

Called when the settings are received from the Server, even if the values are not changed. Should perform any required (re)initialization. Called even if the settings model is empty.

Returns
  Error messages per setting (if any), as in IEngine::setSettings().

Reimplemented from nx::sdk::analytics::Engine.

The documentation for this class was generated from the following files:

- samples/stub_analytics_plugin/src/nx/vms_server_plugins/analytics/stub/engine.h
- samples/stub_analytics_plugin/src/nx/vms_server_plugins/analytics/stub/engine.cpp